#include <fcntl.h>
#include <qdir.h>
#include <krabwidget.h>


#define ktr             klocale->translate
#define MINIMUM_FREE    4096       //Minimum of 4MB free disk space


void KrabWidget::progress_update()
{
	if ( progress_update_run )
	{
//		return;
	}
	progress_update_run = TRUE;
	unsigned long int total_finished_part;
	unsigned long int progress;
	int file_size;
	unsigned int i;

	total_finished_part = 0;
	space_required = 0;

	if ( read_prog_run )
	{
		if ( read_prog_file->exists() )
			file_size = read_prog_file->size();
		else
			file_size = 0;
		if ( (file_size > 0) )
			progress = file_size/(read_prog_final_size/100);
		else
			progress = 0;
		emit ( Status->KProgress_read->setValue( progress ) );
		space_required = read_prog_final_size - file_size;
		if ( todolist->grab_mode == 0 )
			total_finished_part = file_size/2352;
	};
	for ( i=0; i<encoder_max; i++)
	{
		if ( write_prog_run[i] && todolist->grab_mode != 0 )
		{
			if ( write_prog_file[i]->exists() )
				file_size = write_prog_file[i]->size();
			else
				file_size = 0;
			if ( (file_size > 0) )
				progress = ((file_size/1024)*100)/write_prog_final_size[i];
			else
				progress = 0;
			emit ( Status->KProgress_write[i]->setValue( progress ) );
			space_required += (write_prog_final_size[i] * 1024) - file_size;
			if ( todolist->grab_mode != 0 )
				total_finished_part += file_size;
		};
	};
	if ( todolist->grab_mode == 0 )
		progress = ((total_finished + total_finished_part)*100) / total_final_size;
	else
		progress = ( (total_finished + (total_finished_part/1024))*100) / (total_final_size/1024)  ;
	emit ( Status->KProgress_total->setValue( progress ) );
	progress_update_run = FALSE;
};

void KrabWidget::doit( )
{
	unsigned int i;
	working = TRUE;

	if ( todolist->outputPath == "" ) 
	{
		KMsgBox::message( this, ktr( "Error" ) , ktr( "Select an output path first ! \n") );
		return;
	};	
	if ( todolist->tracks == 0 ) 
	{
		KMsgBox::message( this, ktr( "Error" ), ktr( "Select some tracks or files first ! \n" ));
		return;
	};
	if  (!(( !cdda2wav || QCheckBox_cdda_jitter->isChecked()||todolist->grab_mode == 2) && QComboBox_cdda->currentItem() != 8 ))
	{
		if ( todolist->grab_mode == 0 )
			Status = new status_window( 0, "", 0 );
		else
			Status = new status_window( 0, "", encoder_max );
  		connect( Status, SIGNAL(destroy_status()), SLOT(kill_doit()) );
  		connect( Status, SIGNAL(send_signal(unsigned int)), SLOT(send_signal_process(unsigned int)) );
		Status->KSlider_nice->setValue( 19 - nice_level );
		Status->show();
  		connect( Status, SIGNAL(renice(int)), SLOT(renice_process(int)) );

		doit_control_run    = FALSE;
		progress_update_run = FALSE;
		read_prog_run       = FALSE;
		jobnumber           = 0;
		write_jobnumber     = 0;
		for ( i = 0; i <= 5; i++ )
		{
			write_prog_run[i] = FALSE;
			temp_file[i]      = FALSE;
		};
		total_final_size = 0;
		total_finished = 0;
		switch ( todolist->grab_mode )
		{
			case 2: bitrate = bitrate_8hz[QComboBox_8hz_br->currentItem()];
				break;
			case 3: bitrate = bitrate_l3[QComboBox_l3_br->currentItem()];
				break;
			case 4: bitrate = bitrate_mp3[QComboBox_mp3_br->currentItem()];
				break;
			case 5: bitrate = bitrate_blade[QComboBox_blade_br->currentItem()];
				break;
		}
		for ( i = 1; i <= todolist->tracks; i++ )
			total_final_size += todolist->nodes[i];
		if (todolist->grab_mode != 0)
			total_final_size *= ((164 * bitrate)/100);
		
		QTimer_progress = new QTimer ( 0 );
		connect ( QTimer_progress, SIGNAL(timeout()), SLOT(progress_update()) );
		QTimer_progress->start( 200, FALSE );
		QTimer_process = new QTimer ( 0 );
		connect ( QTimer_process, SIGNAL(timeout()), SLOT(doit_control()) );
		QTimer_process->start( 400, FALSE );

		krabwidget_setEnabled( FALSE);
	}
	else QComboBox_cdda_clicked( 0 );
};

void KrabWidget::renice_process( int nice_level_input )
{
	nice_level = 19 - nice_level_input;
	unsigned int i;
	QString temp;
	char convert[8];
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "renice" );
	ostrstream(convert ,8) << nice_level << ends;
	temp = convert;
	*help_prog << temp << "-p";
	if ( read_prog->isRunning() )
	{
		ostrstream(convert ,8) << read_prog->getPid() << ends;
		temp = convert;
		*help_prog << temp;
	}
	for ( i=0; i < 6; i++)
	{
		if ( write_prog[i]->isRunning() )
		{
			ostrstream(convert ,8) << write_prog[i]->getPid() << ends;
			temp = convert;
			*help_prog << temp;
		}
	};
	help_prog->start(KProcess::Block, KProcess::AllOutput);		
	delete help_prog;
};

void KrabWidget::send_signal_process( unsigned int signal )
{
	unsigned int i;
	QString temp;
	char convert[8];
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "kill" );
	*help_prog << "-s" ;
	ostrstream(convert ,8) << signal << ends;
	temp = convert;
	*help_prog << temp;
	if ( read_prog_run )
	{
		ostrstream(convert ,8) << read_prog->getPid() << ends;
		temp = convert;
		*help_prog << temp;
 	};
	for ( i=0; i < 6; i++)
	{
		if ( write_prog_run[i] )
		{
			ostrstream(convert ,8) << write_prog[i]->getPid() << ends;
			temp = convert;
			*help_prog << temp;
		}
	};
	help_prog->start(KProcess::Block, KProcess::AllOutput);		
	delete help_prog;
};

void KrabWidget::doit_control()
{
//	if ( doit_control_run )
//	{
//		return;
//	}
	doit_control_run = TRUE;

	unsigned int i, j, max_write_ok;
	bool device_no_space;
	char convert[3];

        if ( !Status ) return;
	device_no_space = FALSE;

	if ( read_prog_run )
		max_write_ok = jobnumber - 1;
	else
		max_write_ok = jobnumber;
	if ( !read_prog_run  && jobnumber<todolist->tracks )
	{
		j = 0;
		for ( i=0; i < jobnumber; i++)
			if ( temp_file[i] )
				j++;
		if ( j < encoder_max )
		{
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "df" );
			*help_prog << "-k" << todolist->outputPath;
			connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(help_prog_df_stdout(KProcess *, char *, int  ))); 
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			if ( (space_avaible - MINIMUM_FREE) > (2*todolist->nodes[jobnumber + 1]) )
			{
				jobnumber++;
				read_prog_run = TRUE;
				doit_read_prog();
				QString temp;
				temp = ktr ( "read job" );
				temp +=  ": ";
				ostrstream( convert, 3 ) << jobnumber<<ends;
				temp += convert;
				temp += "/";
				ostrstream( convert, 3 ) << todolist->tracks<<ends;
				temp += convert;
				Status->QLabel_Status_read->setText( temp );
				Status->read_led( TRUE );
			}
			else
			{
				device_no_space = TRUE;
			}
		};
	};
	for ( i=0 ; i < encoder_max ; i++)
	{
		if ( !write_prog_run[i] && temp_file[write_jobnumber] && write_jobnumber < jobnumber ) //write_jobnumber +1 -1
		{
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "df" );
			*help_prog << "-k" << todolist->outputPath;
			connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(help_prog_df_stdout(KProcess *, char *, int  ))); 
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			if ( todolist->grab_mode != 0 )
				Status->write_led( TRUE, i );

			write_jobnumber++;
			write_prog_run[i] = TRUE;
			write_job_track[i] = write_jobnumber - 1;
			doit_write_prog(i);
			if ( ((space_avaible-MINIMUM_FREE)) < write_prog_final_size[i] )
			{
				device_no_space = TRUE;
//				disconnect(write_prog[i], SIGNAL(processExited(KProcess *)));
				write_prog[i]->kill(9);
				delete write_prog[i];
				write_prog[i] = NULL;
				Status->write_led( FALSE, i );
				help_prog = new KProcess;
				help_prog->clearArguments();
				help_prog->setExecutable( "rm" );
				*help_prog << "-f" << todolist->outputPath +"/"+ tempfilename[i];
				help_prog->start(KProcess::Block, KProcess::AllOutput);
				delete help_prog;
				write_prog_run[i] = FALSE;
				temp_file[i] = FALSE;
				write_jobnumber--;
			};
		};
	};
	if ( Status && ( jobnumber==todolist->tracks || device_no_space ) && !read_prog_run)
 	{
		for ( i=0 ; i < encoder_max ; i++)
		{
			if ( write_prog_run[i] || temp_file[i] )
				return;
			else 
				if ( write_job_track[i] < max_write_ok)
					max_write_ok = write_job_track[i];
		}

//		disconnect( Status, SIGNAL(destroy_status()) );
		delete QTimer_progress;
		delete QTimer_process;
		QTimer_progress = NULL;
		QTimer_process = NULL;
		Status->total_led( TRUE );
		if ( device_no_space )
		{
			Status->QPushButton_Status_Cancel->setText( ktr( "Aborted !" ) );
		 	KMsgBox::message( this, ktr ("Error"), ktr ( "No space left on device !" ) );	
			for ( i = 1; i <= todolist->tracks; i++)
			{
				todolist->device[i] 		= todolist->device[i+max_write_ok];
				todolist->time[i]   		= todolist->time[i+max_write_ok];
				todolist->group[i] 		= todolist->group[i+max_write_ok];
				todolist->album[i] 		= todolist->album[i+max_write_ok];
				todolist->title[i] 		= todolist->title[i+max_write_ok];
				todolist->year[i] 		= todolist->year[i+max_write_ok];
				todolist->comment[i] 		= todolist->comment[i+max_write_ok];
				todolist->output_filename[i] 	= todolist->output_filename[i+max_write_ok];
				todolist->music_type[i] 	= todolist->music_type[i+max_write_ok];
				todolist->type[i] 		= todolist->type[i+max_write_ok];
				todolist->tracknumber[i] 	= todolist->tracknumber[i+max_write_ok];
				todolist->nodes[i] 		= todolist->nodes[i+max_write_ok];
			}
			todolist->tracks -= max_write_ok;
		}
		else
		{
		 	todolist->tracks = 0;	
			emit ( Status->KProgress_total->setValue( 100 ) );
			Status->QPushButton_Status_Cancel->setText( ktr( "Finished !" ) );
                };
		working = FALSE;
	};
	doit_control_run = FALSE;
};

void KrabWidget::help_prog_df_stdout(KProcess *kp, char *temp_p, int z )
{
	unsigned int i, j; kp=kp; z=z; // I hate compiler warnings...
	temp_p += 104;
	j=0;
	for ( i=1; i<=8 ; i++)
	{
		if ( *temp_p >= 48 &&  *temp_p <=57 ) 
		{
			j += *temp_p++ + j + (j<<3) - 48;
		}
		else
	temp_p++;
	};
	space_avaible = j;
};

void KrabWidget::doit_write_prog( unsigned int process_nr )
{
	QString temp, temp2;
	char convert[4];
	QDir path;
	unsigned int bitrate_temp;

	outputfilename[ process_nr ]  = todolist->outputPath + "/";
	if ( todolist->create_dir_group )
	{
		outputfilename[process_nr] += todolist->group[ write_jobnumber ];
		if ( !path.exists( outputfilename[process_nr], TRUE ) )
			path.mkdir( outputfilename[process_nr], TRUE );
		outputfilename[process_nr] += "/";
	}
	if ( todolist->create_dir_album )
	{
		outputfilename[process_nr] += todolist->album[ write_jobnumber ];
		if ( !path.exists( outputfilename[process_nr], TRUE ) )
			path.mkdir( outputfilename[process_nr], TRUE );
		outputfilename[process_nr] += "/";
	}
	outputfilename[process_nr] += todolist->output_filename[write_jobnumber];
	temp = todolist->output_filename[write_jobnumber];
 	if ( temp.mid(0,11) == "KrabberFile" )
		if (todolist->grab_mode == 0)
		{
		        if ( QCheckBox_wav_raw->isChecked() )
				outputfilename[process_nr] += ".cdr";
			else
				outputfilename[process_nr] += ".wav";
		}
		else
			outputfilename[process_nr] += ".mp3";

	write_prog_final_size[process_nr] = ( todolist->nodes[write_jobnumber] / 1024 );

	if (todolist->grab_mode == 0)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "mv" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead())); 
 		temp = todolist->outputPath +"/"+ tempfilename[write_jobnumber-1];
 		*write_prog[process_nr] << "-f" << temp << outputfilename[process_nr];
		write_prog[process_nr]->start(KProcess::NotifyOnExit);

		const char *temp_p = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp_p );
	};
	if (todolist->grab_mode == 2)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead())); 
		ostrstream( convert , 3 ) << nice_level << ends;
		temp = convert;
		*write_prog[process_nr] << "-n" << temp;
   		temp = QComboBox_8hz_br->text(QComboBox_8hz_br->currentItem());
		ostrstream( convert, 4 ) << bitrate_8hz[QComboBox_8hz_br->currentItem()] << ends;
		temp2 = convert;
 		*write_prog[process_nr] << "8hz-mp3" << "-b" << temp2;
		if ( QCheckBox_8hz_copyright->isChecked() )
			*write_prog[process_nr] << "-c";
		if ( QCheckBox_8hz_original->isChecked() )
			*write_prog[process_nr] << "-o";
 		temp = todolist->outputPath +"/"+ tempfilename[write_jobnumber-1];
 		*write_prog[process_nr] << temp << outputfilename[process_nr];
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

		const char *temp_p = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp_p );
	};
	if (todolist->grab_mode == 3)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead())); 
		ostrstream( convert , 3 ) << nice_level << ends;
		temp = convert;
		*write_prog[process_nr] << "-n" << temp;
   		temp = QComboBox_l3_br->text(QComboBox_l3_br->currentItem());
		ostrstream( convert, 4 ) << bitrate_l3[QComboBox_l3_br->currentItem()] << ends;
		temp2 = convert;
 		*write_prog[process_nr] << KApplication::kde_datadir() + "/krabber/bins/l3enc.start";
		temp = todolist->outputPath +"/"+ tempfilename[write_jobnumber-1];
 		*write_prog[process_nr] << temp;
		temp = todolist->outputPath +"/"+ tempfilename[write_jobnumber-1] + ".mp3";
 		*write_prog[process_nr] << temp;
		*write_prog[process_nr] << "-br" << temp2 + "000";
		if ( QCheckBox_l3_crc->isChecked() )
			*write_prog[process_nr] << "-crc";
		if ( QCheckBox_l3_hq->isChecked() )
			*write_prog[process_nr] << "-hq";
		if ( QCheckBox_l3_speech->isChecked() )
			*write_prog[process_nr] << "-spch";
		if ( !QCheckBox_cdda_stereo->isChecked() )
			*write_prog[process_nr] << "-dm";
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

		const char *temp_p = temp;
		write_prog_file[process_nr] = new QFile( temp_p );
	};
	if (todolist->grab_mode == 4)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead())); 
		ostrstream( convert , 3 ) << nice_level << ends;
		temp = convert;
		*write_prog[process_nr] << "-n" << temp;
   		temp = QComboBox_mp3_br->text(QComboBox_mp3_br->currentItem());
		ostrstream( convert, 4 ) << bitrate_mp3[QComboBox_mp3_br->currentItem()] << ends;
		temp2 = convert;
		temp2 += "000"; 
		*write_prog[process_nr] << "mp3enc" << "-br" << temp2 << "-qual";
		ostrstream(convert, 2) << QComboBox_mp3_ql->currentItem()<<ends;
		temp=convert;
		*write_prog[process_nr] << temp;
		if ( !QCheckBox_cdda_stereo->isChecked() )
			*write_prog[process_nr] << "-dm";
		if ( QComboBox_cdda->currentItem() == 7 )
			*write_prog[process_nr] << "-bw" << "22050";
		if ( QComboBox_cdda->currentItem() == 5 )
			*write_prog[process_nr] << "-bw" << "11025";
 		temp = todolist->outputPath +"/"+ tempfilename[write_jobnumber-1];
 		*write_prog[process_nr] << "-if" << temp << "-of" << outputfilename[process_nr];
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

		const char *temp_p = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp_p );
	};
	if (todolist->grab_mode == 5)
	{
		help_prog = new KProcess;
		help_prog->clearArguments();
		help_prog->setExecutable( "mv" );
		*help_prog << "-f" << todolist->outputPath +"/"+ tempfilename[write_jobnumber-1] << todolist->outputPath +"/"+ tempfilename[write_jobnumber-1] + ".wav";
		help_prog->start(KProcess::Block, KProcess::AllOutput);
		delete help_prog;

		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead())); 
		ostrstream( convert , 3 ) << nice_level << ends;
		temp = convert;
		*write_prog[process_nr] << "-n" << temp;
   		temp = QComboBox_blade_br->text(QComboBox_blade_br->currentItem());
		ostrstream( convert, 4 ) << bitrate_blade[QComboBox_blade_br->currentItem()] << ends;
		temp2 = convert;
 		*write_prog[process_nr] << KApplication::kde_datadir() + "/krabber/bins/bladeenc.start" << "-" + temp2 << "-QUIT";
		if ( QCheckBox_blade_copyright->isChecked() )
			*write_prog[process_nr] << "-COPYRIGHT";
		else
			*write_prog[process_nr] << "-COPY";
		if ( QCheckBox_blade_private->isChecked() )
			*write_prog[process_nr] << "-PRIVATE";
		if ( QCheckBox_blade_crc->isChecked() )
			*write_prog[process_nr] << "-CRC";
		if ( !QCheckBox_cdda_stereo->isChecked() )
			*write_prog[process_nr] << "-MONO";
 		temp = todolist->outputPath +"/"+ tempfilename[write_jobnumber-1] + ".wav";
 		*write_prog[process_nr] << temp;
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

 		temp = todolist->outputPath +"/"+ tempfilename[write_jobnumber-1] + ".mp3";
		write_prog_file[process_nr] = new QFile( temp );
	};

	bitrate_temp = ((164 * bitrate)/100);
	write_prog_final_size[process_nr] *= bitrate_temp;
};

void KrabWidget::write_prog_dead()
{
	unsigned int process_nr;

	for ( process_nr=0; process_nr<encoder_max; process_nr++ )
	{
	  if ( write_prog_run[process_nr] == TRUE && write_prog[process_nr]!=NULL )
	  {
	    if ( !write_prog[process_nr]->isRunning() )
	    {
		delete write_prog[process_nr];
		write_prog[process_nr] = NULL;
		if ( todolist->grab_mode == 5 || todolist->grab_mode == 3 )
		{
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "mv" );
			*help_prog << "-f" << todolist->outputPath +"/"+ tempfilename[write_job_track[process_nr]] + ".mp3" << outputfilename[process_nr];
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "rm" );
			if ( todolist->grab_mode == 5 )
				*help_prog << "-f" << todolist->outputPath +"/"+ tempfilename[write_job_track[process_nr]] + ".wav";
			else
				*help_prog << "-f" << todolist->outputPath +"/"+ tempfilename[write_job_track[process_nr]];
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			Status->write_led( FALSE, process_nr );
			emit ( Status->KProgress_write[process_nr]->setValue( 0 ) );
	        }
		else if ( todolist->grab_mode != 0 )
		{
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "rm" );
			*help_prog << "-f" << todolist->outputPath +"/"+ tempfilename[write_job_track[process_nr]];
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			Status->write_led( FALSE, process_nr );
			emit ( Status->KProgress_write[process_nr]->setValue( 0 ) );
      		};
		QFile *output_file;
		output_file = new QFile(  outputfilename[process_nr] );
		if ( !( output_file->exists()) )
		{
		        KMsgBox::message( this, ktr ( "Error" ), ktr ( "Something goes wrong.... \n\n - Maybe you have no write permission\n - or you have an incorrect filename (esp. on non ext2 filesystems)\n - or an encoder problem\n\n Sorry... hope you find the error ! :-(" ) );
			kill_doit();
			return;
		};
		delete output_file;
		if ( todolist->grab_mode != 0 && QCheckBox_mp3_header->isChecked() )
			write_mp3_header( outputfilename[process_nr], write_job_track[process_nr] + 1 );
		temp_file[write_job_track[process_nr]] = FALSE;
                write_prog_run[process_nr] = FALSE;
	        delete write_prog_file[process_nr];
		write_prog_file[process_nr] = NULL;

		if ( todolist->grab_mode != 0 )
			total_finished += write_prog_final_size[process_nr];
	        };
	    }; 
	};
};

void KrabWidget::write_mp3_header( QString file_name, unsigned int number )
{
	QString output_string, temp, temp_fill;
	unsigned int genre;

	char convert[6];
//	char *test = alloca ( 5 );
/*	struct mp3_tag_v1
	{
		char title[30];
		char group[30];
		char album[30];
		char year[4];
		char comment[30];
		char type[1];
	};
  */

	FILE * file;
	file = fopen ( file_name, "r+" );
	fflush( file );
/*	fseek(file, -128, SEEK_END);
	fflush( file );
	fread(test, 3, 1, file);
	if (!strncmp(*test, "TAG", 3))
		fseek(file, -128, SEEK_END);
	else
*/		fseek(file, 0, SEEK_END);
	fflush( file );

	output_string  = "TAG";
	temp = todolist->title[ number ];
	temp = temp.left(30);
	temp_fill.fill(' ', (30 - temp.length()) );
	output_string += temp + temp_fill;
	temp = todolist->group[ number ];
	temp = temp.left(30);
	temp_fill.fill(' ', (30 - temp.length()) );
	output_string += temp + temp_fill;
	temp = todolist->album[ number ];
	temp = temp.left(30);
	temp_fill.fill(' ', (30 - temp.length()) );
	output_string += temp + temp_fill;
	ostrstream ( convert, 5 ) << todolist->year[ number ] <<ends;
	temp = convert;
	temp = temp.left(4);
	temp_fill.fill(' ', (4 - temp.length()) );
	output_string += temp.left(4) + temp_fill;
	temp = todolist->comment[ number ];
	temp = temp.left(30);
	temp_fill.fill(' ', (30 - temp.length()) );
	output_string += temp + temp_fill;

	const char *output = output_string;

	temp = todolist->title[ number ];
  
	genre = todolist->music_type[ number ];
	fflush( file );
	fwrite(output, 1, 127, file);
	fflush( file );
	fwrite(&genre, 1, 1, file);
	fflush( file );

	if ( output_string.length() != 127 )
		cout << "XXXXXXXXXXXX" <<endl << "WARNING     INTERNAL KRABBER ERROR  ---  MP3 TAG DAMAGED" <<endl<<endl;

        fclose( file );
//	delete file;
};
void KrabWidget::doit_read_prog()
{
	QString temp, temp3;
	char temp2[3];

	ostrstream ( temp2, 3 ) << jobnumber <<ends;
	temp = temp2;
	tempfilename[ jobnumber - 1 ] = "Krabber_temp_file_" + todolist->krabber_process_id + "_" + temp;

	if (todolist->type[jobnumber] == 1)
	{
		read_prog = new KProcess;
		read_prog->clearArguments ();
		read_prog_final_size = todolist->nodes[jobnumber] * 2340; // eigentlich 2352....

		if ( ( (QCheckBox_cdda_stereo->isChecked() || 
			( !QCheckBox_cdda_stereo->isChecked() &&  todolist->grab_mode != 2 )))
		      && QCheckBox_cdda_16bit->isChecked() 
                      && ( QComboBox_cdda->currentItem() == 8 
			|| ((QComboBox_cdda->currentItem() == 7 || QComboBox_cdda->currentItem() == 5) && todolist->grab_mode==4 ) ) )
		{
		        read_prog->setExecutable ( "cdparanoia" );
		        *read_prog << "-d" <<  todolist->device[jobnumber] ;
		        if ( !QCheckBox_cdda_jitter->isChecked() )
				 *read_prog <<"-Z";
			if ( todolist->grab_mode == 0 )
				if ( QCheckBox_wav_raw->isChecked() )
					*read_prog << "-p";
		}
		else
		{
			read_prog = new KProcess;
		        read_prog->setExecutable ( "cdda2wav" );	
              		*read_prog << "-D" << todolist->device[jobnumber];
       	                if ( QCheckBox_cdda_stereo->isChecked() )
			         *read_prog << "-s" ;
		        else
			{
			         *read_prog << "-m" ;
				 read_prog_final_size = read_prog_final_size/2;
			}
		        if (QCheckBox_cdda_16bit->isChecked())
   			         *read_prog << "-b"<<"16" ;
		        else
			{
			         *read_prog << "-b" << "8" ;
				 read_prog_final_size = read_prog_final_size/2;
			}
		        *read_prog << "-r"<< QComboBox_cdda->text(QComboBox_cdda->currentItem()) ;  	   
		        *read_prog << "-d"<<"0"<<"-t" ;

			if( QComboBox_cdda->currentItem() == 0 )
				read_prog_final_size = read_prog_final_size/49;
			if( QComboBox_cdda->currentItem() == 1 )
				read_prog_final_size = read_prog_final_size/28;
			if( QComboBox_cdda->currentItem() == 2 )
				read_prog_final_size = read_prog_final_size/14;
			if( QComboBox_cdda->currentItem() == 3 )
				read_prog_final_size = read_prog_final_size/12;
			if( QComboBox_cdda->currentItem() == 4 )
				read_prog_final_size = read_prog_final_size/6;
			if( QComboBox_cdda->currentItem() == 5 )
				read_prog_final_size = read_prog_final_size/4;
			if( QComboBox_cdda->currentItem() == 6 )
				read_prog_final_size = read_prog_final_size/3;
			if( QComboBox_cdda->currentItem() == 7 )
				read_prog_final_size = read_prog_final_size/2;
		}
 		ostrstream(temp2, 3 ) << todolist->tracknumber[jobnumber] << ends;
 		temp3 = temp2;
		*read_prog << temp3;
		temp = todolist->outputPath + "/" + tempfilename[jobnumber - 1];
		*read_prog << temp ;
       	        connect(read_prog, SIGNAL(processExited(KProcess *)), SLOT(read_prog_dead()));
		read_prog->start(KProcess::NotifyOnExit, KProcess::AllOutput);
	};
	if (todolist->type[jobnumber] == 2 || todolist->type[jobnumber] == 3)
	{
		read_prog_final_size = todolist->nodes[jobnumber] * 2340; // eigentlich 2352....
		read_prog = new KProcess;
		read_prog->clearArguments ();
		read_prog->setExecutable( "amp" );
  	        connect(read_prog, SIGNAL(processExited(KProcess *)), SLOT(read_prog_dead()));
		*read_prog << "-convert" << "-w";
		*read_prog <<todolist->device[jobnumber] ;
		temp = todolist->outputPath + "/" + tempfilename[jobnumber - 1];
		*read_prog << temp;
		read_prog->start(KProcess::NotifyOnExit, KProcess::AllOutput);
   	};
	if (todolist->type[jobnumber] == 4)
	{
		read_prog = new KProcess;
		read_prog_final_size = todolist->nodes[jobnumber] * 2048;
		read_prog->clearArguments ();
		read_prog->setExecutable ( "cp" );
  	        connect(read_prog, SIGNAL(processExited(KProcess *)), SLOT(read_prog_dead()));
		*read_prog << "-f";
		temp3= todolist->device[jobnumber];
		*read_prog << temp3;
  		*read_prog << todolist->outputPath + "/" + tempfilename[jobnumber - 1];
  		read_prog->start(KProcess::NotifyOnExit);//, KProcess::AllOutput);
    	};
	temp = todolist->outputPath +"/" + tempfilename[jobnumber - 1];
	const char *temp_p = temp;
	read_prog_file = new QFile( temp_p ) ;
};

void KrabWidget::read_prog_dead( )
{
	QString temp;

	if ( read_prog_run == TRUE && !read_prog->isRunning() )
	{
		delete read_prog;
                read_prog = NULL;
		Status->read_led( FALSE );
		emit ( Status->KProgress_read->setValue( 0 ) );
		read_prog_run = FALSE;
		temp_file[jobnumber - 1] = TRUE;
		delete read_prog_file;
		if ( todolist->grab_mode == 0 )
			total_finished += todolist->nodes[jobnumber];
	}
};

void KrabWidget::kill_doit()
{
	unsigned int process_nr, max_write_ok, i;
	char temp[1024];

	disconnect( Status, SIGNAL(destroy_status()) );
	delete QTimer_progress;
	delete QTimer_process;
	QTimer_progress = NULL;
	QTimer_process = NULL;

	if ( read_prog != NULL )
	{
	  if ( read_prog->isRunning()  )
 	  {
		read_prog_run = FALSE;
		read_prog->kill(9);
		delete read_prog;
		read_prog = NULL;
		help_prog = new KProcess;
		help_prog->clearArguments();
		help_prog->setExecutable( "rm" );
		*help_prog << "-f" << todolist->outputPath +"/"+ tempfilename[jobnumber - 1];
		help_prog->start(KProcess::Block, KProcess::AllOutput);
		delete help_prog;
		max_write_ok = jobnumber - 1;
	  }
	else
		max_write_ok = jobnumber ; 
	}
	else
		max_write_ok = jobnumber ;

	for ( process_nr = 0; process_nr < encoder_max; process_nr++ )
	{
		write_prog_run[process_nr] = FALSE;	
		if ( (write_job_track[process_nr] < max_write_ok) && write_prog[process_nr] != NULL )
		  if ( write_prog[process_nr]->isRunning() )
			max_write_ok = write_job_track[process_nr];
		if ( write_prog[process_nr] != NULL )
		  if ( write_prog[process_nr]->isRunning() )
		  {
			write_prog[process_nr]->kill(9);
			delete  write_prog[process_nr];
			write_prog[process_nr] = NULL;
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "rm" );
			if ( todolist->grab_mode == 3 )
			{
				ostrstream( temp, 1024 ) << todolist->outputPath  << "/" << tempfilename[write_job_track[process_nr]] <<ends;
				*help_prog << "-f" << temp;
				ostrstream( temp, 1024 ) << todolist->outputPath << "/" << tempfilename[write_job_track[process_nr]] << ".mp3" <<ends;
				*help_prog << temp;
			};
			if ( todolist->grab_mode == 5 )
			{
				ostrstream( temp, 1024 ) << todolist->outputPath  << "/" << tempfilename[write_job_track[process_nr]] << ".wav"<<ends;
				*help_prog << "-f" << temp;
				ostrstream( temp, 1024 ) << todolist->outputPath << "/" << tempfilename[write_job_track[process_nr]] << ".mp3" <<ends;
				*help_prog << temp;
			};
			if ( todolist->grab_mode != 3 && todolist->grab_mode != 5 && todolist->grab_mode != 0 )
			{
				ostrstream( temp, 1024 ) << todolist->outputPath << "/" << tempfilename[write_job_track[process_nr]]<< ends;
				*help_prog << "-f" << temp;
				ostrstream( temp, 1024 ) << outputfilename[ write_job_track[process_nr] - 1 ] << ends;
				*help_prog << temp;
			};
			help_prog->start(KProcess::Block);//, KProcess::AllOutput);
			delete help_prog;
		  };
	};

	delete Status;
	Status = NULL;
	if ( todolist->tracks != 0)
	{
		for ( i = 1; i <= todolist->tracks; i++)
		{
			todolist->device[i] 		= todolist->device[i+max_write_ok];
			todolist->time[i]   		= todolist->time[i+max_write_ok];
			todolist->group[i] 		= todolist->group[i+max_write_ok];
			todolist->album[i] 		= todolist->album[i+max_write_ok];
			todolist->title[i] 		= todolist->title[i+max_write_ok];
			todolist->year[i] 		= todolist->year[i+max_write_ok];
			todolist->comment[i] 		= todolist->comment[i+max_write_ok];
			todolist->output_filename[i] 	= todolist->output_filename[i+max_write_ok];
			todolist->music_type[i] 	= todolist->music_type[i+max_write_ok];
			todolist->type[i] 		= todolist->type[i+max_write_ok];
			todolist->tracknumber[i] 	= todolist->tracknumber[i+max_write_ok];
			todolist->nodes[i] 		= todolist->nodes[i+max_write_ok];
		};
		todolist->tracks -= max_write_ok;
	};

	krabwidget_setEnabled( TRUE );
	todolist_update();
};

